Poj 3126 Prime Path

Prime Path

Time Limit: 1000MSMemory Limit: 65536K
Total Submissions: 48104Accepted: 24996

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

思路:BFS+线性筛 找到符合条件的素数便入队,直到队空或者找到结果。

#include<iostream>
#include<queue>
#include<vector>
#include<cstring>
#include<string.h>
#include<string>
#include<cstdio>
using namespace std;

const int N = 10010;

int isPrime[N];
int visit[N];

int check(int a, int b){
	int ans = 0;
	while(a != 0 && b != 0){
		if(a % 10 != b % 10){
			ans++;
		}
		a /= 10;
		b /= 10;
	}
	return ans;
}

int bfs(int start,int end){
	queue<pair<int,int> >que;
	que.push({start,0});
	visit[start] = 1;
	
	while(que.size()){
		pair<int,int> temp = que.front();
		//cout << temp.first << endl;
		que.pop();
		
		if(temp.first == end){
			return temp.second;
		}
		
		for(int i = 1001;i < N;i++){
			if(!isPrime[i] && !visit[i] && check(temp.first,i) == 1){
				que.push({i,temp.second + 1});
				visit[i] = 1;
				//break;
			}else{
				continue;
			}
		}
	}
	return -1;
}

int main()
{
	vector<int>prime;
	for(int i = 2;i < N;i++){
		if(!isPrime[i]) prime.push_back(i);
		for(int j = 0;j < prime.size() && i * prime[j] < N;j++){
			isPrime[i*prime[j]] = 1;
			if(i % prime[j] == 0){
				break;
			}
		}
	}
	int n;
	while(~scanf("%d",&n)){
		for(int i = 0;i < n;i++){
			int start,end;
			scanf("%d%d",&start,&end);
			memset(visit,0,sizeof(visit));
			int ans = bfs(start,end);
			if(ans != -1){
				cout << ans << endl;
			}else{
				cout << "Impossible" << endl;
			}
		}
	}
	
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值